VERSION 5.00
Begin VB.Form Form1 
   BackColor       =   &H00C0E0FF&
   Caption         =   "Form1"
   ClientHeight    =   6045
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5970
   LinkTopic       =   "Form1"
   ScaleHeight     =   403
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   398
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkModPal 
      Caption         =   "Inverse Beetle's Palette"
      Height          =   330
      Left            =   3705
      TabIndex        =   8
      Top             =   5580
      Width           =   2100
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Load GIF from URL (Example)"
      Height          =   420
      Left            =   285
      TabIndex        =   7
      Top             =   5520
      Width           =   3330
   End
   Begin VB.CheckBox chkMirror 
      Caption         =   "Mirror Animation"
      Height          =   495
      Left            =   3720
      TabIndex        =   6
      Top             =   5040
      Width           =   2055
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Play"
      Height          =   420
      Index           =   3
      Left            =   2835
      TabIndex        =   5
      ToolTipText     =   "Resume animation"
      Top             =   5070
      Width           =   780
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Fwd"
      Height          =   420
      Index           =   2
      Left            =   1980
      TabIndex        =   4
      ToolTipText     =   "Moves animation to next frame"
      Top             =   5070
      Width           =   780
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Pause"
      Height          =   420
      Index           =   1
      Left            =   1125
      TabIndex        =   3
      ToolTipText     =   "Pauses animation at current frame"
      Top             =   5070
      Width           =   780
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Stop"
      Height          =   420
      Index           =   0
      Left            =   285
      TabIndex        =   2
      ToolTipText     =   "Stops animation and displays 1st frame"
      Top             =   5070
      Width           =   780
   End
   Begin VB.Frame Frame1 
      Caption         =   "Frame1"
      Height          =   1800
      Left            =   210
      TabIndex        =   1
      Top             =   210
      Width           =   3255
      Begin prjGIFViewer.ucAniGIF ucAniGIF 
         Height          =   900
         Index           =   0
         Left            =   525
         Top             =   480
         Width           =   2100
         _ExtentX        =   3704
         _ExtentY        =   1588
         GIF             =   "Form1.frx":0000
         Delay           =   40
         Loops           =   1000
      End
   End
   Begin VB.PictureBox Picture1 
      BackColor       =   &H008080FF&
      Height          =   2715
      Left            =   195
      Picture         =   "Form1.frx":1C62
      ScaleHeight     =   2655
      ScaleWidth      =   5550
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   2220
      Width           =   5610
      Begin prjGIFViewer.ucAniGIF ucAniGIF 
         Height          =   750
         Index           =   3
         Left            =   390
         ToolTipText     =   "Image loaded from Remote path"
         Top             =   900
         Width           =   1290
         _ExtentX        =   2275
         _ExtentY        =   1323
         GIF             =   "Form1.frx":11D96
         Enabled         =   0   'False
      End
      Begin prjGIFViewer.ucAniGIF ucAniGIF 
         Height          =   2250
         Index           =   2
         Left            =   1995
         Top             =   180
         Width           =   3375
         _ExtentX        =   5953
         _ExtentY        =   3969
         GIF             =   "Form1.frx":11DAE
      End
   End
   Begin prjGIFViewer.ucAniGIF ucAniGIF 
      Height          =   1905
      Index           =   1
      Left            =   3555
      Top             =   150
      Width           =   2250
      _ExtentX        =   3969
      _ExtentY        =   3360
      GIF             =   "Form1.frx":36A9C
      Loops           =   1000
      Mirror          =   1
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Keep these things in mind when you play.

' 1. VB is single threaded. The more animated GIFs on the form, the longer it
'   will take for all of them to begin animation.
'   - The DelayAnimation property helps the form load faster
'   - When DelayAnimation=False, form will take more time to initially display

' 2. Compile the usercontrol. If uncompiled, you can expect these common annoyances:
'   - When MsgBox pops up, images disappear until Msgbox is closed
'   - Dragging other windows over a static GIF (stopped animating) may not repaint immediately

' 3. The dotted border in design time does not disappear. It is purposely painted to:
'   - Identify the animated GIF control from a normal VB image control
'   - Show you the bounds of the overall image

' 4. Do not overlap image controls if possible.
'   - Overlapped controls forward paint events to every control above it in the zOrder
'   - Having several controls overlapped theoretically can bog down your application

' 5. For performance reasons, you should pause or stop animation when your app is minimized

Option Explicit


Private Sub chkModPal_Click()

    ' Example of modifying the GIF's palette
    ' Can be useful if you GIF needs to change colors depending on user selections/actions
    
    Dim P As Long, pEntries() As Long
    Dim R As Integer, G As Integer, B As Integer, E As Long
    
    For P = 0 To ucAniGIF(2).FrameCount
        If ucAniGIF(2).GetPalette(P, pEntries()) = True Then
        
            For E = 0 To UBound(pEntries)
                ' inverse the RGB colors. Remember that palette entires are BGR, not RGB
                B = 255 - (pEntries(E) And &HFF)
                G = 255 - ((pEntries(E) \ &H100) And &HFF)
                R = 255 - ((pEntries(E) \ &H10000) And &HFF)
                
                pEntries(E) = RGB(B, G, R)
                
            Next
            ucAniGIF(2).SetPalette P, pEntries()
        End If
    Next
End Sub

Private Sub Command1_Click(Index As Integer)
    Dim I As Integer, Action As AnimationActions
    Select Case Index
        Case 0: Action = gfaStop
        Case 1: Action = gfaPause
        Case 2: Action = gfaForward
        Case 3: Action = gfaPlay
    End Select
    For I = ucAniGIF.LBound To ucAniGIF.UBound
        ucAniGIF(I).Action = Action
    Next
End Sub

Private Sub chkMirror_Click()
    Dim I As Integer
    For I = ucAniGIF.LBound To ucAniGIF.UBound  ' toggle horizontal mirroring
        ucAniGIF(I).Mirrored = ucAniGIF(I).Mirrored Xor gfmHorizontal
    Next
End Sub

Private Sub Command2_Click()

    If MsgBox("Two things." & vbCrLf & _
        "1. Click Yes to retrieve the GIF, no links will be activated." & vbCrLf & _
        "2. Notice the images disappearing? Once OCX is compiled or EXE is compiled, this won't happen", _
        vbInformation + vbYesNo, "Continue?") = vbNo Then Exit Sub

    ' this will not activate the link
    ucAniGIF(3).LoadAnimatedGIF_Remote "http://www.animation-station.com/shared/coollinks.gif"
    ' the remote path can be a server too: i.e., \\myserver\my pictures\mygif.gif or a hard drive path
End Sub

Private Sub Form_Load()
    chkMirror.BackColor = Me.BackColor
    chkModPal.BackColor = Me.BackColor
    Command2.ToolTipText = "Target URL is http://www.animation-station.com/shared/coollinks.gif"
End Sub

Private Sub Form_Resize()
    ' Example of pausing animation while minimized
    Dim I As Integer
    Dim oldAction As AnimationActions, newAction As AnimationActions
    
    If Me.WindowState = vbMinimized Then
        oldAction = gfaPlay
        newAction = gfaPause
    Else
        oldAction = gfaPause
        newAction = gfaPlay
    End If
    
    For I = ucAniGIF.LBound To ucAniGIF.UBound
        If ucAniGIF(I).Action = oldAction Then ucAniGIF(I).Action = newAction
    Next

End Sub

Private Sub ucAniGIF_RemoteLoadComplete(Index As Integer, ByVal gifWidth As Single, ByVal gifHeight As Single, ByRef Cancel As Boolean)
    ' When you called the LoadAnimatedGIF_Remote routine, (See Command2_Click)
    ' this event will be fired if the file was successfully read and the header
    ' of the file indicates it is a GIF.
    
    ' Set Cancel to True to prevent loading it.
    ' Otherwise, it will be displayed with the current settings of the usercontrol
    Command2.Enabled = False  ' successfully downloaded sample URL gif
    
    With ucAniGIF(Index)                ' to be a little thourough
        Set .AnimatedGIF = Nothing  ' remove previous image before changing attributes
        .Stretch = gfsActualSize    ' set scale
        .DelayAnimation = gfdNone   ' set delay mode
        .Mirrored = gfmNone         ' set mirror options
        .Enabled = True             ' enable it
    End With                        ' next, the image will be processed and displayed

End Sub

Private Sub ucAniGIF_RemoteLoadFailure(Index As Integer)
    ' When you called the LoadAnimatedGIF_Remote routine, this event will be fired if the
    ' file was NOT successfully read, errors occurred or the header of the file indicates
    ' it is NOT a GIF.
    MsgBox "Failed to download/read the remote GIF file", vbInformation + vbOKOnly
    
End Sub
